
/*------------------------------------------------------------------------
    File        : GetActiveDirProp.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Thu Feb 13 13:42:29 EST 2014
    Notes       :
  ----------------------------------------------------------------------*/
USING System.DirectoryServices.*.
USING System.DirectoryServices.AccountManagement.*.

DEFINE VARIABLE objContext    AS PrincipalContext.
DEFINE VARIABLE objUser       AS UserPrincipal.
DEFINE VARIABLE objDirEntry   AS DirectoryEntry.
DEFINE VARIABLE objProps      AS PropertyCollection.
DEFINE VARIABLE PropertyValue AS CHARACTER          NO-UNDO.
DEFINE VARIABLE PropertyName  AS CHARACTER          NO-UNDO.

PropertyName = "Description".

/*objContext = NEW PrincipalContext(ContextType:Domain,"YourDomain").*/
objContext = NEW PrincipalContext(ContextType:Machine).

objUser = UserPrincipal:FindByIdentity(objContext,"TestUser").
IF objUser = ? THEN RETURN ?.
 
/* There are many common properties on the UserPrincipal object. We try first
   to use this as it's faster */
PropertyValue = DYNAMIC-PROPERTY(objUser,PropertyName) NO-ERROR.

/* If the above failed, probably because the property requested is not valid for
   UserPrincipal, then we'll go for the property as a directory entry */
IF ERROR-STATUS:NUM-MESSAGES GT 0 THEN 
DO:
  objDirEntry = CAST(objUser:GetUnderlyingObject(),DirectoryEntry).
  objProps = objDirEntry:Properties.
  IF NOT objProps:Contains(PropertyName) THEN RETURN ?.
  PropertyValue = objProps:Item[PropertyName]:Value.
      
END.  

MESSAGE PropertyValue
  VIEW-AS ALERT-BOX.
    