 
/*------------------------------------------------------------------------
   File        : Trapezoid
   Purpose     : 
   Syntax      : 
   Description : 
   Author(s)   : Tom.Bergman
   Created     : Thu Jan 30 18:07:42 EST 2014
   Notes       : Converted from the demo in the MS docs for the Math class
   http://msdn.microsoft.com/en-us/library/system.math(v=vs.110).aspx
 ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING System.*.



CLASS Trapezoid: 

  /*------------------------------------------------------------------------------
   Purpose:
   Notes:
  ------------------------------------------------------------------------------*/
  DEFINE VARIABLE m_longbase  AS DECIMAL NO-UNDO.
  DEFINE VARIABLE m_shortbase AS DECIMAL NO-UNDO.
  DEFINE VARIABLE m_leftleg   AS DECIMAL NO-UNDO.
  DEFINE VARIABLE m_rightleg  AS DECIMAL NO-UNDO.
	
		
  CONSTRUCTOR PUBLIC Trapezoid ( INPUT 
    longbase AS DECIMAL,
    shortbase AS DECIMAL,
    leftleg AS DECIMAL,
    rightleg AS DECIMAL)
    :
	    
    SUPER ().
    m_longbase = Math:Abs(longbase).
    m_shortbase = Math:Abs(shortbase).
    m_leftleg = Math:Abs(leftleg).
    m_rightleg = Math:Abs(rightleg).
        
		
  END CONSTRUCTOR.


  /*------------------------------------------------------------------------------
   Purpose:
   Notes:
  ------------------------------------------------------------------------------*/

  METHOD PUBLIC DECIMAL GetLeftBaseDegreeAngle(  ):
		
    DEFINE VARIABLE x AS DECIMAL NO-UNDO.
    x = GetLeftBaseRadianAngle() * 180 / Math:PI.
    RETURN Math:Round(x,2).
        
  END METHOD.

  /*------------------------------------------------------------------------------
   Purpose:
   Notes:
  ------------------------------------------------------------------------------*/

  METHOD PUBLIC DECIMAL GetLeftBaseRadianAngle(  ):
		
    DEFINE VARIABLE x    AS DECIMAL NO-UNDO.
    DEFINE VARIABLE sinX AS DECIMAL NO-UNDO.
		
    sinX = GetHeight() / m_leftLeg.
    RETURN Math:Round(Math:Asin(sinX),2).

		
  END METHOD.

  /*------------------------------------------------------------------------------
   Purpose:
   Notes:
  ------------------------------------------------------------------------------*/

  METHOD PUBLIC DECIMAL GetHeight(  ):
		DEFINE VARIABLE x AS DECIMAL NO-UNDO.
    x = GetRightSmallBase().
    RETURN Math:Sqrt(Math:Pow(m_rightLeg,2.0) - Math:Pow(x,2.0)).

  END METHOD.     

  /*------------------------------------------------------------------------------
   Purpose:
   Notes:
  ------------------------------------------------------------------------------*/

  METHOD PUBLIC DECIMAL GetRightBaseDegreeAngle(  ):
		
    DEFINE VARIABLE x AS DECIMAL NO-UNDO.
    x = GetRightBaseRadianAngle() * 180 / Math:PI.
    RETURN Math:Round(x,2).
		
  END METHOD.

  /*------------------------------------------------------------------------------
   Purpose:
   Notes:
  ------------------------------------------------------------------------------*/
	
  METHOD PUBLIC DECIMAL GetRightBaseRadianAngle(  ):
		
    DEFINE VARIABLE x    AS DECIMAL NO-UNDO.
    DEFINE VARIABLE cosX AS DECIMAL NO-UNDO.
    x = GetRightSmallBase().
    cosX = (Math:Pow(m_rightLeg,2.0) + Math:Pow(x,2.0) - Math:Pow(GetHeight(),2.0)) / (2 * x * m_rightLeg).
    RETURN Math:Round(Math:Acos(cosX),2).
        
  END METHOD.

  /*------------------------------------------------------------------------------
   Purpose:
   Notes:
  ------------------------------------------------------------------------------*/

  METHOD PUBLIC DECIMAL GetRightSmallBase(  ):
		
    DEFINE VARIABLE x AS DECIMAL NO-UNDO.
    RETURN  (Math:Pow(m_rightLeg,2.0) - Math:Pow(m_leftLeg,2.0) + Math:Pow(m_longBase,2.0) + Math:Pow(m_shortBase,2.0) - 2 * m_shortBase * m_longBase) / (2 * (m_longBase - m_shortBase)).

  END METHOD.

END CLASS.